import { CzmParticleEmitterJsonType, ESSceneObject, NativeNumber16Type, PickedInfo, Player, PositionEditing, PrsEditing, RotationEditing } from "vtxf-xe2/dist-node/xe2-base-objects";
import { Event, Listener, PartialWithUndefinedReactivePropsToNativeProps, ReactivePropsToNativePropsAndChanged } from "vtxf-xe2/dist-node/xe2-base-utils";
import { SceneObjectKey } from "vtxf-xe2/dist-node/xe2-utils";
import { CzmParticleSystemPrimitiveParticleBurstType } from "./CzmParticleSystemPrimitiveParticleBurstType";
import { CzmParticleSystemPrimitiveUpdateCallbackType } from "./CzmParticleSystemPrimitiveUpdateCallbackType";
export { CzmParticleSystemPrimitiveUpdateCallbackType };
export declare type CzmParticleSystemPrimitiveImageType = string | HTMLImageElement | HTMLCanvasElement | URL;
export declare class CzmParticleSystemPrimitive extends ESSceneObject {
    static readonly type: string;
    get typeName(): string;
    get defaultProps(): {
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("vtxf-xe2/dist-node/xe2-base-utils").JsonValue>;
        allowPickingDepth: boolean;
        allowPicking: boolean;
        position: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number] | undefined>;
        rotation: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number]>;
        modelMatrix: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<NativeNumber16Type | undefined>;
        editing: boolean;
        positionEditing: boolean;
        rotationEditing: boolean;
        localPosition: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number]>;
        localRotation: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number]>;
        localScale: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number]>;
        localModelMatrix: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<NativeNumber16Type | undefined>;
        emitter: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<CzmParticleEmitterJsonType>;
        bursts: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<CzmParticleSystemPrimitiveParticleBurstType[]>;
        imageStr: string | undefined;
        imageSize: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number] | undefined>;
        minimumImageSize: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number] | undefined>;
        maximumImageSize: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number] | undefined>;
        show: boolean;
        updateCallbackStr: string | undefined;
        emissionRate: number;
        loop: boolean;
        scale: number | undefined;
        startScale: number | undefined;
        endScale: number | undefined;
        color: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number] | undefined>;
        startColor: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number] | undefined>;
        endColor: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number] | undefined>;
        sizeInMeters: boolean;
        speed: number | undefined;
        minimumSpeed: number | undefined;
        maximumSpeed: number | undefined;
        lifetime: number | undefined;
        particleLife: number | undefined;
        minimumParticleLife: number | undefined;
        maximumParticleLife: number | undefined;
        mass: number | undefined;
        minimumMass: number | undefined;
        maximumMass: number | undefined;
        playingLoop: boolean;
        currentTime: number;
        duration: number;
        playingSpeed: number;
        playing: boolean;
        viewDistance: number | undefined;
    };
    get json(): JsonType;
    set json(value: JsonType);
    private _flyToEvent;
    get flyToEvent(): Listener<[number | undefined]>;
    flyTo(duration?: number): void;
    private _pickedEvent;
    get pickedEvent(): Event<[PickedInfo]>;
    private _player;
    get player(): Player;
    private _updateCallback;
    get updateCallback(): Function | undefined;
    set updateCallback(value: Function | undefined);
    get updateCallbackChanged(): Listener<[Function | undefined, Function | undefined]>;
    private _updateCallbackStrInit;
    private _forceRecreteEvent;
    get forceRecreteEvent(): Listener;
    forceRecrete(): void;
    private _image;
    get image(): CzmParticleSystemPrimitiveImageType | undefined;
    set image(value: CzmParticleSystemPrimitiveImageType | undefined);
    get imageChanged(): Listener<[CzmParticleSystemPrimitiveImageType | undefined, CzmParticleSystemPrimitiveImageType | undefined]>;
    private _imageStrInit;
    get ratio(): number;
    set ratio(value: number);
    get ratioChanged(): Listener<[number, number]>;
    private _sPositionEditing;
    get sPositionEditing(): PositionEditing;
    private _sRotationEditing;
    get sRotationEditing(): RotationEditing;
    private _sPrsEditing;
    get sPrsEditing(): PrsEditing;
    setPresets(type: 'origin' | 'smoke' | 'explosion' | 'drain' | 'fire' | 'waveTail'): void;
    private _applyCurentViewDistanceEvent;
    get applyCurentViewDistanceEvent(): Listener;
    applyCurentViewDistance(): void;
    constructor(id?: SceneObjectKey);
    static defaults: {
        position: [number, number, number];
        modelMatrix: NativeNumber16Type;
        localModelMatrix: NativeNumber16Type;
        scale: number;
        startScale: number;
        endScale: number;
        color: [number, number, number, number];
        startColor: [number, number, number, number];
        endColor: [number, number, number, number];
        speed: number;
        minimumSpeed: number;
        maximumSpeed: number;
        particleLife: number;
        maximumParticleLife: number;
        minimumParticleLife: number;
        mass: number;
        minimumMass: number;
        maximumMass: number;
        imageSize: [number, number];
        minimumImageSize: [number, number];
        maximumImageSize: [number, number];
        lifetime: number;
        imageStr: string;
        viewerTagsEnums: [string, string][];
    };
    getProperties(language?: string): import("vtxf-xe2/dist-node/xe2-base-objects").Property[];
}
export declare namespace CzmParticleSystemPrimitive {
    const createDefaultProps: () => {
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("vtxf-xe2/dist-node/xe2-base-utils").JsonValue>;
        allowPickingDepth: boolean;
        allowPicking: boolean;
        position: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number] | undefined>;
        rotation: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number]>;
        modelMatrix: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<NativeNumber16Type | undefined>;
        editing: boolean;
        positionEditing: boolean;
        rotationEditing: boolean;
        localPosition: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number]>;
        localRotation: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number]>;
        localScale: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number]>;
        localModelMatrix: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<NativeNumber16Type | undefined>;
        emitter: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<CzmParticleEmitterJsonType>;
        bursts: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<CzmParticleSystemPrimitiveParticleBurstType[]>;
        imageStr: string | undefined;
        imageSize: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number] | undefined>;
        minimumImageSize: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number] | undefined>;
        maximumImageSize: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number] | undefined>;
        show: boolean;
        updateCallbackStr: string | undefined;
        emissionRate: number;
        loop: boolean;
        scale: number | undefined;
        startScale: number | undefined;
        endScale: number | undefined;
        color: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number] | undefined>;
        startColor: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number] | undefined>;
        endColor: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number] | undefined>;
        sizeInMeters: boolean;
        speed: number | undefined;
        minimumSpeed: number | undefined;
        maximumSpeed: number | undefined;
        lifetime: number | undefined;
        particleLife: number | undefined;
        minimumParticleLife: number | undefined;
        maximumParticleLife: number | undefined;
        mass: number | undefined;
        minimumMass: number | undefined;
        maximumMass: number | undefined;
        playingLoop: boolean;
        currentTime: number;
        duration: number;
        playingSpeed: number;
        playing: boolean;
        viewDistance: number | undefined;
    };
}
export interface CzmParticleSystemPrimitive extends ReactivePropsToNativePropsAndChanged<ReturnType<typeof CzmParticleSystemPrimitive.createDefaultProps>> {
}
declare type JsonType = PartialWithUndefinedReactivePropsToNativeProps<ReturnType<typeof CzmParticleSystemPrimitive.createDefaultProps> & {
    type: string;
}>;
