import { CzmTerrainProviderJsonType, ESSceneObject } from "vtxf-xe2/dist-node/xe2-base-objects";
import { Event, Listener, PartialWithUndefinedReactivePropsToNativeProps, ReactivePropsToNativePropsAndChanged } from "vtxf-xe2/dist-node/xe2-base-utils";
import { SceneObjectKey } from "vtxf-xe2/dist-node/xe2-utils";
import * as Cesium from 'cesium';
export declare function getFinalTerrainProviderUrl(url: string): string | Promise<Cesium.IonResource> | undefined;
export declare function getFinalTerrainProviderUrlString(url: string): string | undefined;
export declare function getCzmCodeFromCzmTerrain(czmTerrain: CzmTerrain): string | undefined;
export declare class CzmTerrain extends ESSceneObject {
    static readonly type: string;
    get typeName(): string;
    get defaultProps(): {
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("vtxf-xe2/dist-node/xe2-base-utils").JsonValue>;
        show: boolean | undefined;
        rectangle: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[west: number, south: number, east: number, north: number] | undefined>;
        height: number | undefined;
        provider: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<CzmTerrainProviderJsonType | undefined>;
    };
    get json(): JsonType;
    set json(value: JsonType);
    private _flyToEvent;
    get flyToEvent(): Listener<[number | undefined]>;
    flyTo(duration?: number): void;
    private _recreateEvent;
    get recreateEvent(): Event<[]>;
    recreate(): void;
    getCzmCode(): string | undefined;
    constructor(id?: SceneObjectKey);
    static defaults: {
        show: boolean;
        rectangle: [number, number, number, number];
        height: number;
        provider: CzmTerrainProviderJsonType;
        viewerTagsEnums: [string, string][];
    };
    getProperties(language?: string): import("vtxf-xe2/dist-node/xe2-base-objects").Property[];
}
export declare namespace CzmTerrain {
    const createDefaultProps: () => {
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("vtxf-xe2/dist-node/xe2-base-utils").JsonValue>;
        show: boolean | undefined;
        rectangle: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<[west: number, south: number, east: number, north: number] | undefined>;
        height: number | undefined;
        provider: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<CzmTerrainProviderJsonType | undefined>;
    };
}
export interface CzmTerrain extends ReactivePropsToNativePropsAndChanged<ReturnType<typeof CzmTerrain.createDefaultProps>> {
}
declare type JsonType = PartialWithUndefinedReactivePropsToNativeProps<ReturnType<typeof CzmTerrain.createDefaultProps> & {
    type: string;
}>;
export {};
